      subroutine vvvvmd(g,u1,l1,u2,l2,u3,l3,u4,mat)
c----------------------------------------------------------------------c
c Returns a matrix element for a quartic gauge boson vertex 
c
c Input: u1,u2,u3,u4 - vectors,
c        l1,l2,l3,l4 - position of u1,u2,u3 and u4 in the vertex,
c        g - a quartic gauge boson coupling.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 4 May, 2007; modified on 15 May, 2007; 
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0)
      integer :: l1,l2,l3
      complex(dp) :: mat,g
      complex(dp), dimension(0:3) :: u1,u2,u3,u4,ev

c      if ((l1 < 3 .and. l2 < 3) .or. (l3 < 3 .and. l4 < 3)) then
      if ((l1 < 3 .and. l2 < 3) .or. (l1 > 2 .and. l2 > 2)) then
           ev=-g*((u1(0)*u3(0)
     &            -u1(1)*u3(1)
     &            -u1(2)*u3(2)
     &            -u1(3)*u3(3))*u2
     &           +(u2(0)*u3(0)
     &            -u2(1)*u3(1)
     &            -u2(2)*u3(2)
     &            -u2(3)*u3(3))*u1
     &      -2.d0*(u1(0)*u2(0)
     &            -u1(1)*u2(1)
     &            -u1(2)*u2(2)
     &            -u1(3)*u2(3))*u3)
c      else if ((l1 < 3 .and. l3 < 3) .or. (l2 < 3 .and. l4 < 3)) then
      else if ((l1 < 3 .and. l3 < 3) .or. (l1 > 2 .and. l3 > 2)) then
           ev=-g*( (u1(0)*u2(0)
     &             -u1(1)*u2(1)
     &             -u1(2)*u2(2)
     &             -u1(3)*u2(3))*u3
     &            +(u3(0)*u2(0)
     &             -u3(1)*u2(1)
     &             -u3(2)*u2(2)
     &             -u3(3)*u2(3))*u1
     &       -2.d0*(u1(0)*u3(0)
     &             -u1(1)*u3(1)
     &             -u1(2)*u3(2)
     &             -u1(3)*u3(3))*u2)
c      else if ((l1 < 3 .and. l4 < 3) .or. (l2 < 3 .and. l3 < 3)) then
      else if ((l2 > 2 .and. l3 > 2) .or. (l2 < 3 .and. l3 < 3)) then
           ev=-g*( (u1(0)*u3(0)
     &             -u1(1)*u3(1)
     &             -u1(2)*u3(2)
     &             -u1(3)*u3(3))*u2
     &            +(u2(0)*u1(0)
     &             -u2(1)*u1(1)
     &             -u2(2)*u1(2)
     &             -u2(3)*u1(3))*u3
     &       -2.d0*(u3(0)*u2(0)
     &             -u3(1)*u2(1)
     &             -u3(2)*u2(2)
     &             -u3(3)*u2(3))*u1)
      end if

      mat=ev(0)*u4(0)-ev(1)*u4(1)-ev(2)*u4(2)-ev(3)*u4(3)

      end subroutine vvvvmd
