      subroutine matchkk(i,e1,j,e2,iord,plord,ncls,id,sgn)
c----------------------------------------------------------------------c
c Matches two particles into a matrix element
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 12 April, 2006; modified on 15 Sept. 2006; 16 Feb. 2007;
c 7 April 2014: particle mixing added
c 26 March, 2015: printing of the control info changed
c----------------------------------------------------------------------c

      use extpart
      use intpart
      use vertices

      implicit none

      integer :: i,j,iord,plord(next),ncls,id,sgn,ihel,oifi,oifj,
     &           plij,plii,plio,plig,plif,plict,plin,plie,
     &           pljj,plji,pljo,pljg,pljf,pljct,pljn,plje

      integer :: e1,e2,k,j1,j2


      if (pl(i)%mx+pl(j)%mx == 4) return     ! 7 April 2014

      open(16,file='partcls.tmp',access='direct',form='formatted',
     &                                                     recl=80)
      read(16,1612,rec=i) plij,plii,plio,plig,plif,plict,plin,plie
      read(16,1612,rec=j) pljj,plji,pljo,pljg,pljf,pljct,pljn,plje
 1612 format(i8,5(i3),i24,i3)

      close(16)

      if (plie + plje < next) return

      if (plig == pljg) then
       if (plig == 0) then
        if (plij == 24 .and. pljj == 24) then
         if (plii == -plji) then
          ihel=plin*pljn
          if (ihel /= nhel) then
           write(*,*)'matchkk.f 1: Incorrect No of helicities',ihel
           stop
          end if
          id=id+1
          write(*,'(a,i12,a,2i10)')'Diagram',id, ! added on 26 March, 2015
     &                           '  made of particles:',i,j
          if (e1 < e2) then
           iord=-1
          else
           iord=1
          end if
          call backwrite(i,j,ncls,plord,id,sgn)
         end if
        else
         if (plij == pljj) then
          ihel=plin*pljn
          if (ihel /= nhel) then
           write(*,*)'matchkk.f 2: Incorrect No of helicities',ihel
           stop
          end if
          id=id+1
          write(*,'(a,i12,a,2i10)')'Diagram',id, ! added on 26 March, 2015
     &                           '  made of particles:',i,j
          if (e1 < e2) then
           iord=-1
          else
           iord=1
          end if
          call backwrite(i,j,ncls,plord,id,sgn)
         else   ! Check if the particles i and j mix with each other.
          if (max(pl(i)%mx,pl(j)%mx) < 2) then
           do k=1,nbba
            oifi=plio*plii*plij
            do j1=1,2
             if (oifi == mcbb(k,j1)) then
              oifj=pljo*plji*pljj
              do j2=1,2
               if (j1 /= j2 .and. oifj == mcbb(k,j2)) then
                id=id+1
                write(*,'(a,i12,a,2i10)')'Diagram',id, ! added on 26 March, 2015
     &                           '  made of particles:',i,j
                if (e1 < e2) then
                 iord=-1
                else
                 iord=1
                end if
                call mixwrite(i,j,ncls,plord,id,sgn,gbb(k))
               end if
              end do
             end if
            end do
           end do
          end if
         end if
        end if
       else
        oifi=plio*plii*plif
        oifj=pljo*plji*pljf
        if (oifi == -oifj) then
         ihel=plin*pljn
         if (ihel /= nhel) then
          write(*,*)'matchkk.f 3: Incorrect No of helicities',ihel
          stop
         end if
         id=id+1
         write(*,'(a,i12,a,2i10)')'Diagram',id, ! added on 26 March, 2015
     &                            '  made of particles:',i,j
         if (oifi > oifj) then
          if (e1 < e2) then
           iord=-1
          else
           iord=1
          end if
          call backwrite(i,j,ncls,plord,id,sgn)
         else
          if (e1 < e2) then
           iord=1
          else
           iord=-1
          end if
          call backwrite(j,i,ncls,plord,id,sgn)
         end if
        end if
       end if
      end if

      end subroutine matchkk
