      module maxvals

      character(80), parameter :: prvrsn=
c Maximum values of some parameters for
     &         'carlomat, version 4.0 of 31 January, 2022'

      integer, parameter :: 
     &      nffb=60,         ! No of ffb vertices
     &      nbbb=30,         ! No of bbb vertices
     &      nbbbb=20,        ! No of bbbb vertices
     &      mxbb=10,         ! No of bb mixings
     &      ncol=3,          ! No of colours
     &      mxprt=100,       ! Max No of particles in a model
     &      mxepl=13,        ! Max No of external particles
     &      mxipl=200000,    ! Max No of intermediate particles
     &      mxvpl=6,         ! Max No of similar vertices, 
     &                       ! e.g. uua, uuz, uuh, uug
     &      mxmpl=10,        ! Max No of similar particle mixings,
     &                       ! e.g. arho0, aom0, aphi0
     &      mxmap=4,         ! Max No of particles in a subsystem whose 
     &                       ! propagator should be mapped
     &      mxphot=5,        ! Max # of external photons
     &      mxks=100         ! Max # of s-channel kinematics for ischnl=2
      integer, parameter :: 
     &      mxncnt=19,       ! Max No of continuation lines,
     &      mxcmdl=500,      ! Max No of lines in selected routines (e.g. 
     &                       ! mdkk*.f, mmodkk*.f) 
     &      mxcmdb=20,       ! Max No of blocks in selected routines (e.g. 
     &                       ! kin*kk*.f). Relevant for speeding up
     &                       ! their compilation.
     &      mxcmdc=20        ! No of colour factors to be computed in one
     &                       ! subroutine of colsqkk.f. Relevant for speeding 
     &                       ! up the compilation.

c Numbers of the diagram topolgies:
      integer, parameter :: ntop_4=4, ntop_5=25, ntop_6=220, 
     &                      ntop_7=2485, ntop_8=34300, ntop_9=559405, 
     &                      ntop_10=10525900, ntop_11=224449225

      real(kind(1.d0)), parameter :: rcold=1.d-12 ! accuracy for 
                                                  ! comparisons of the color 
                                                  ! factors

c Masses of virtual particles that form poles in the Feynman propagators,
c (should be consistent with those in modpart.dat):
      integer, parameter :: ntpl=2, nspl=10
c the t-chanel pole particles with zero mass:
      character(2), parameter :: mtpl(ntpl)=(/'ma','mg'/)
c the s-chanel pole particles:
      character(4), parameter :: mspl(nspl)=
     &               (/'ma  ','mg  ','mz  ','mh  ','mw  ',
     &                 'mrho','mome','mphi','mrh1','mrh2'/)
c the t-quark pole:
      character(2), parameter :: mqpl='mt'

      end module maxvals

