c=============================================================================c
c Matrix element of the process:
c
c                      e+ e-  ->  mu+ mu- ta+ ta- a
c
c generated with carlomat, version 4.0 of 15 August, 2021
c with the MC summing over polarizations
c
c                            Karol Kolodziej
c                         University of Silesia
c                            Katowice, Poland
c                      e-mail: karol.kolodziej@us.edu.pl
c=============================================================================c
 
      subroutine matrixel(p,phi,mat2)
 
      use inprms
      use couplsmkk
      use hmodkk
      use pmodkk
      use umodkk
 
      implicit none
 
      integer, parameter :: next= 7, nmcs= 7
      real(qp) :: p(0:3,next)
      real(dp) :: phi(nmcs),mat2,comif
      integer :: first=1,hl
 
      integer, parameter :: rdgs=1
      integer, parameter :: nhip=4, nidp=1, ncip=1
      real(16) :: mpol2
 
      save first,comif
 
      p1=p(:,1)
      p2=p(:,2)
      p3=p(:,3)
      p4=p(:,4)
      p5=p(:,5)
      p6=p(:,6)
      p7=p(:,7)
 
      call spinor_qp(p1,me,-1,-1,1,phi(1),u1,1)
      call spinor_qp(p2,me,1,-1,1,phi(2),u2,1)
      call spinor_qp(p3,mmu,-1,1,1,phi(3),u3,1)
      call spinor_qp(p4,mmu,1,1,1,phi(4),u4,1)
      call spinor_qp(p5,mtau,-1,1,1,phi(5),u5,1)
      call spinor_qp(p6,mtau,1,1,1,phi(6),u6,1)
      if (igauge == 1) then
       do hl=1,1
        u7(:,hl)=cmplx(p7,0.d0,dp)
       end do
      else
       call recpol_qp(p7,ma,1,phi(7),u7,1)
      end if
 
      call mtel1
 
      if (first == 1) then
       comif=1.d0/(nhip*nidp*ncip)
       first=0
      end if
  
      mat2=0.d0
  
      do hl=1,nhel
       mat2=mat2+mpol2(hl)
      end do
  
      mat2=comif*mat2
  
      end subroutine matrixel
