      function pi3(ecm)
c----------------------------------------------------------------------c
c The analytic cross section of
c                e+ e- -> pi+ pi- pi0
c
c Input:  ecm - c.m.s. enrgy in GeV
c
c based on pi3.f by Fred Jegerlehner
c 5 Dec., 2016
c----------------------------------------------------------------------c
      use mathprms
      use inprms

      implicit none

      real(dp) :: pi3,ecm,OMRES,S,MOM,GOM,POM,ALPI,ALP,FBW,FAC,FACT,SMM,
     &            BROMPI3

      S=ecm**2
      MOM=0.78268D0       ! +/- 0.08 +/- 0.04 from cmd2 fit
      GOM=8.68D-3         ! +/- 0.23 +/- 0.10 from cmd2 fit
      POM=6.95D-5         ! pm 0.15d-5
      ALPI=137.035999084D0 ! pm (51) April 2008
      ALP =1.D0/ALPI
C conversion factor GeV**(-2)->nb
      FACT=0.3893857D6
      FACT=convc
C conversion of Breight-Wigner FUNCTION BW() to R!
      FBW=9.D0/4.D0*ALPI**2
C sigma(ee->mumu)=FAC/S (S in GeV**2)
      FAC=4.D0*PI*ALP**2/3.D0*FACT
C e^+ e^- -> mu^+ mu^- lowest order cross section to convert sigma to R
      SMM=FAC/S
C branching fractions 
C OMEGA Decays including gamma's like pi^0-gamma not included
      BROMPI3=0.8920d0

      OMRES=BW(S,MOM,GOM,POM)*FBW*SMM
c      FIRES=BWZSGFI(S,MFI,GFI,PFI)*FBW*SMM

      pi3=OMRES*BROMPI3!+FIRES*BRFIPI3
c         ,SQRT((OMSTA*BROMPI3)**2+(FISTA*BRFIPI3)**2)

      contains
       FUNCTION BW(S,M,G,P)
C      --------------------
C      BREIT WIGNER
       IMPLICIT NONE
       REAL(dp) :: BW,S,M,G,P
       BW=G**2*P/((DSQRT(S)-M)**2+G**2/4.D0)
       RETURN
       END function BW

      end
